#include <bits/stdc++.h>
using namespace std;
const int N=75050;
int n,m;
long long a[N],b[N];
int main(){
    int t;scanf("%i",&t);
    while(t--){
        scanf("%i %i",&n,&m);
        for(int i=0;i<n;i++)scanf("%lld",&a[i]);
        for(int i=0;i<m;i++)scanf("%lld",&b[i]);
        sort(a,a+n);sort(b,b+m);
        long long gcd1=a[1]-a[0],gcd2=b[1]-b[0];
        for(int i=1;i<n;i++)gcd1=__gcd(gcd1,a[i]-a[i-1]);
        for(int i=1;i<m;i++)gcd2=__gcd(gcd2,b[i]-b[i-1]);
        /*//cout<<gcd1<<" "<<gcd2<<'\n';
        if(gcd2>gcd1){
            printf("0\n");
            continue;
        }
        if(gcd1%gcd2==0){
            printf("0\n");
        }else{
            printf("1\n");
        }*/
        bool ok=1;
        for(int i=0;i<n;i++)if(abs(a[0]-b[i])%gcd1==0)ok=0;
        printf("%i\n",ok);
    }
    return 0;
}